Index: issm/trunk/src/m/consistency/checkfield.py
===================================================================
--- issm/trunk/src/m/consistency/checkfield.py	(revision 25994)
+++ issm/trunk/src/m/consistency/checkfield.py	(revision 26744)
@@ -11,14 +11,13 @@
 
     Used to check model consistency
-        
     Requires:
-        'field' or 'fieldname' option. If 'fieldname' is provided, it will 
+        'field' or 'fieldname' option. If 'fieldname' is provided, it will
         retrieve it from the model md. (md.(fieldname))
-        If 'field' is provided, it will assume the argument following 'field' 
+        If 'field' is provided, it will assume the argument following 'field'
         is a numeric array.
 
     Available options:
         - NaN: 1 if check that there is no NaN
-        - size: [lines cols], NaN for non checked dimensions, or 'universal' 
+        - size: [lines cols], NaN for non checked dimensions, or 'universal'
         for any input type (nodal, element, time series, etc)
         - > :  greater than provided value
@@ -72,6 +71,5 @@
         fieldsize = options.getfieldvalue('size')
         if type(fieldsize) == str:
-            if m.strcmp(fieldsize, 'universal'):
-
+            if fieldsize == 'universal':
                 #Check that vector size will not be confusing for ModelProcessorx
                 if (md.mesh.numberofvertices == md.mesh.numberofelements):
Index: issm/trunk/src/m/consistency/ismodelselfconsistent.m
===================================================================
--- issm/trunk/src/m/consistency/ismodelselfconsistent.m	(revision 25994)
+++ issm/trunk/src/m/consistency/ismodelselfconsistent.m	(revision 26744)
@@ -3,5 +3,5 @@
 %
 %   Usage:
-%      ismodelselfconsistent(md),
+%      ismodelselfconsistent(md);
 
 %initialize consistency as true
@@ -52,4 +52,6 @@
 	elseif strcmp(solutiontype,'MasstransportSolution')
 		analyses={'MasstransportAnalysis'};
+	elseif strcmp(solutiontype,'OceantransportSolution')
+		analyses={'OceantransportAnalysis'};
 	elseif strcmp(solutiontype,'BalancethicknessSolution')
 		analyses={'BalancethicknessAnalysis'};
@@ -71,11 +73,13 @@
 		analyses={'EsaAnalysis'};
 	elseif strcmp(solutiontype,'TransientSolution')
-		analyses={'StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis','EnthalpyAnalysis','MasstransportAnalysis','HydrologyShaktiAnalysis','HydrologyGladsAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis','SealevelriseAnalysis'};
-	elseif strcmp(solutiontype,'SealevelriseSolution')
-		analyses={'SealevelriseAnalysis'};
+		analyses={'StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis','EnthalpyAnalysis','MasstransportAnalysis','OceantransportAnalysis','HydrologyShaktiAnalysis','HydrologyGladsAnalysis','HydrologyShreveAnalysis','HydrologyTwsAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis','SealevelchangeAnalysis'};
+	elseif strcmp(solutiontype,'SealevelchangeSolution')
+		analyses={'SealevelchangeAnalysis'};
 	elseif strcmp(solutiontype,'HydrologySolution')
-		analyses={'L2ProjectionBaseAnalysis','HydrologyShreveAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis'};
+		analyses={'L2ProjectionBaseAnalysis','HydrologyShreveAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis','HydrologyGladsAnalysis','HydrologyShaktiAnalysis','HydrologyTwsAnalysis'};
 	elseif strcmp(solutiontype,'DamageEvolutionSolution')
 		analyses={'DamageEvolutionAnalysis'};
+    elseif strcmp(solutiontype,'SamplingSolution')
+		analyses={'SamplingAnalysis'};    
 	else
 		error(' solution type: %s' , solutiontype, ' not supported yet!');
Index: issm/trunk/src/m/consistency/ismodelselfconsistent.py
===================================================================
--- issm/trunk/src/m/consistency/ismodelselfconsistent.py	(revision 25994)
+++ issm/trunk/src/m/consistency/ismodelselfconsistent.py	(revision 26744)
@@ -1,11 +1,10 @@
 def ismodelselfconsistent(md):  #{{{
-    '''
-    ISMODELSELFCONSISTENT - check that model forms a closed form solvable problem.
+    """ISMODELSELFCONSISTENT - check that model forms a closed form solvable problem.
 
-       Usage:
-          ismodelselfconsistent(md),
-    '''
+    Usage:
+        ismodelselfconsistent(md)
+    """
 
-    #initialize consistency as true
+    # Initialize consistency as true
     md.private.isconsistent = True
 
@@ -13,35 +12,34 @@
     # exit()
 
-    #Get solution and associated analyses
+    # Get solution and associated analyses
     solution = md.private.solution
     analyses = AnalysisConfiguration(solution)
-    #Go through a model fields, check that it is a class, and call checkconsistency
+    # Go through a model fields, check that it is a class, and call checkconsistency
     #fields = vars(md)
     #for field in fields.iterkeys():
     for field in md.properties():
-        #Some properties do not need to be checked
+        # Some properties do not need to be checked
         if field in ['results', 'debug', 'radaroverlay']:
             continue
 
-        #Check that current field is an object
+        # Check that current field is an object
         if not hasattr(getattr(md, field), 'checkconsistency'):
             md.checkmessage('field {} is not an object.'.format(field))
 
-        #Check consistency of the object
-        exec("md.{}.checkconsistency(md, '{}', {})".format(field, solution, analyses))
+        # Check consistency of the object
+        exec('md.{}.checkconsistency(md, \'{}\', {})'.format(field, solution, analyses))
 
-    #error message if mode is not consistent
+    # Error message if mode is not consistent
     if not md.private.isconsistent:
         raise RuntimeError('Model not consistent, see messages above.')
-#}}}
+# }}}
 
 
 def AnalysisConfiguration(solutiontype):  #{{{
-    '''
-    ANALYSISCONFIGURATION - return type of analyses, number of analyses
+    """ANALYSISCONFIGURATION - return type of analyses, number of analyses
 
-        Usage:
-                [analyses] = AnalysisConfiguration(solutiontype)
-    '''
+    Usage:
+        [analyses] = AnalysisConfiguration(solutiontype)
+    """
 
     if solutiontype == 'StressbalanceSolution':
@@ -53,4 +51,6 @@
     elif solutiontype == 'MasstransportSolution':
         analyses = ['MasstransportAnalysis']
+    elif solutiontype == 'OceantransportSolution':
+        analyses = ['OceantransportAnalysis']
     elif solutiontype == 'BalancethicknessSolution':
         analyses = ['BalancethicknessAnalysis']
@@ -72,14 +72,16 @@
         analyses = ['EsaAnalysis']
     elif solutiontype == 'TransientSolution':
-        analyses = ['StressbalanceAnalysis', 'StressbalanceVerticalAnalysis', 'StressbalanceSIAAnalysis', 'L2ProjectionBaseAnalysis', 'ThermalAnalysis', 'MeltingAnalysis', 'EnthalpyAnalysis', 'MasstransportAnalysis', 'HydrologyShaktiAnalysis', 'HydrologyGladsAnalysis', 'HydrologyDCInefficientAnalysis', 'HydrologyDCEfficientAnalysis', 'SealevelriseAnalysis']
-    elif solutiontype == 'SealevelriseSolution':
-        analyses = ['SealevelriseAnalysis']
+        analyses = ['StressbalanceAnalysis', 'StressbalanceVerticalAnalysis', 'StressbalanceSIAAnalysis', 'L2ProjectionBaseAnalysis', 'ThermalAnalysis', 'MeltingAnalysis', 'EnthalpyAnalysis', 'MasstransportAnalysis', 'OceantransportAnalysis', 'HydrologyShaktiAnalysis', 'HydrologyGladsAnalysis', 'HydrologyShreveAnalysis', 'HydrologyTwsAnalysis', 'HydrologyDCInefficientAnalysis', 'HydrologyDCEfficientAnalysis', 'SealevelchangeAnalysis']
+    elif solutiontype == 'SealevelchangeSolution':
+        analyses = ['SealevelchangeAnalysis']
     elif solutiontype == 'HydrologySolution':
-        analyses = ['L2ProjectionBaseAnalysis', 'HydrologyShreveAnalysis', 'HydrologyDCInefficientAnalysis', 'HydrologyDCEfficientAnalysis']
+        analyses = ['L2ProjectionBaseAnalysis', 'HydrologyShreveAnalysis', 'HydrologyDCInefficientAnalysis', 'HydrologyDCEfficientAnalysis', 'HydrologyGladsAnalysis', 'HydrologyShaktiAnalysis', 'HydrologyTwsAnalysis']
     elif 'DamageEvolutionSolution':
         analyses = ['DamageEvolutionAnalysis']
+    elif 'SamplingSolution':
+        analyses = ['SamplingAnalysis']
     else:
         raise TypeError('solution type: {} not supported yet!'.format(solutiontype))
 
     return analyses
-#}}}
+# }}}
Index: issm/trunk/src/m/contrib/adhikari/wahr.m
===================================================================
--- issm/trunk/src/m/contrib/adhikari/wahr.m	(revision 26744)
+++ issm/trunk/src/m/contrib/adhikari/wahr.m	(revision 26744)
@@ -0,0 +1,58 @@
+function [vert, horz] = wahr(disc_rad,xi,love_h,love_l); 
+% a function to compute vertical and horizontal crustal motion... 
+% ...for a disc load, inspired by Figure 1 of Wahr et al., 2013. 
+% 
+% usage: 
+%		[vert, horz] = wahr(disc_rad,xi,love_h,love_l); 
+%		
+%		vert = vertical crustal motion [m] 
+%		horz = horizontal crustal motion [m] 
+%		disc_rad = disc radius [m] => set to 20 km to replicate the Wahr experiment. 
+%		xi = grid points along the distance away from the disc center [m] 
+%		love_h = load Love numbers h for the vertical crustal motion. 
+%		love_l = load Love numbers l for the horizontal crustal motion. 
+%		
+
+	disc_rad = disc_rad/1000; % km 
+	% compute P(x), dP(x)/dx, d2P(x)/dx2
+	%---------------------------------------------------------------------
+	% compute p_value 
+	theta=km2deg(xi/1000)';
+	ang = theta/180*pi; 
+	alpha=cos(ang);
+	m=length(alpha);
+	n=length(love_h)-1; 
+	p_value = p_polynomial_value(m,n,alpha);
+	p_prime = p_polynomial_prime(m,n,alpha);
+	%---------------------------------------------------------------------
+	nn=[0:n];
+	nn_plus_1=nn+1; 
+
+	% disc radius in degree 
+	disc_rad = km2deg(disc_rad)/180*pi; 
+	tau=zeros(size(love_h)); 
+	tau(1) = 0.5*(1-cos(disc_rad)); % tau_0 
+	p_value_disc = p_polynomial_value(1,n+1,cos(disc_rad));
+	p_prime_disc = p_polynomial_prime(1,n,cos(disc_rad));
+	for jj=2:n+1
+		nnn = jj-1; 
+		tau(jj) = 0.5 * (p_value_disc(jj-1) - p_value_disc(jj+1)); 
+	end
+
+	const=zeros(size(love_h)); 
+	for jj=1:n+1
+		const(jj) = 1/(2*(jj-1)+1); 
+	end
+
+	disc=sum(bsxfun(@times,p_value,tau'),2); 
+
+	g1 = -sum(bsxfun(@times,p_value,(tau.*love_h.*const)'),2); 
+	g5 = -sum(bsxfun(@times,-sin(ang),bsxfun(@times,p_prime,(tau.*love_l.*const)')),2); 
+
+	% coeff 
+	coeff = 1000*4*pi*(6.67408*10^-11)*(6.3781*10^6)/9.81; 
+
+	% vertical and horizontal solutions
+	vert = g1*coeff; % m 
+	horz = g5*coeff; % m 
+
Index: issm/trunk/src/m/contrib/chenggong/interpFromMEaSUREsGeotiff.m
===================================================================
--- issm/trunk/src/m/contrib/chenggong/interpFromMEaSUREsGeotiff.m	(revision 26744)
+++ issm/trunk/src/m/contrib/chenggong/interpFromMEaSUREsGeotiff.m	(revision 26744)
@@ -0,0 +1,40 @@
+% This function calls src/m/contrib/morlighem/modeldata/interpFromGeotiff.m for multiple times to load all avaliable 
+% tif data in  /totten_1/ModelData/Greenland/VelMEaSUREs/Jakobshavn_2008_2021/ within the given time period (in decimal years)
+% For some reason, each .tif file in this folder contains two sets of data, only the first dataset is useful
+
+function dataout = interpFromMEaSUREsGeotiff(X,Y,Tstart,Tend)
+
+foldername = '/totten_1/ModelData/Greenland/VelMEaSUREs/Jakobshavn_2008_2021/';
+
+% get the time info from file names
+templist = dir([foldername,'*.meta']);
+Ndata = length(templist);
+dataTstart = zeros(Ndata,1);
+dataTend = zeros(Ndata,1);
+
+for i = 1:Ndata
+	tempConv = split(templist(i).name, '_');
+	% follow the naming convention
+	dataPrefix(i) = join(tempConv(1:5), '_');
+	dataTstart(i) = date2decyear(datenum(tempConv{3}));
+	dataTend(i) = date2decyear(datenum(tempConv{4}));
+end
+disp(['  Found ', num2str(Ndata), ' records in ', foldername]);
+disp(['    from ', datestr(decyear2date(min(dataTstart)),'yyyy-mm-dd'), ' to ', datestr(decyear2date(max(dataTend)),'yyyy-mm-dd') ]);
+
+
+% find all the data files with Tstart<=t<=Tend
+dataInd = (dataTend>=Tstart) & (dataTstart<=Tend);
+disp([' For the selected period: ', datestr(decyear2date((Tstart)),'yyyy-mm-dd'), ' to ', datestr(decyear2date((Tend)),'yyyy-mm-dd'), ', there are ', num2str(sum(dataInd)), ' records' ]);
+
+dataToLoad = dataPrefix(dataInd);
+TstartToload = dataTstart(dataInd);
+TendToload = dataTend(dataInd);
+
+for i = 1:length(dataToLoad)
+	dataout(i).vx = interpFromGeotiff([foldername, dataToLoad{i}, '_vx_v04.0.tif'], X, Y, 2e9);
+	dataout(i).vy = interpFromGeotiff([foldername, dataToLoad{i}, '_vy_v04.0.tif'], X, Y, 2e9);
+	dataout(i).vel = interpFromGeotiff([foldername, dataToLoad{i}, '_vv_v04.0.tif'], X, Y, -1);
+	dataout(i).Tstart = TstartToload(i);
+	dataout(i).Tend = TendToload(i);
+end
Index: issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py	(revision 25994)
+++ issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py	(revision 26744)
@@ -3,23 +3,55 @@
 import time
 import collections
-from inspect import isclass, getmodule
+from inspect import isclass
 from os import path, remove
 
 
 class ResTable:
-
     def __init__(self):
         self.data = []
-
-    def update(self, row):
-        if len(np.shape(row)) == 0:
-            self.data.append(row)
-        else:
-            for r in row:
+        self.sizes = []
+
+    def update(self, stepvar):
+        #if we have a scalar we just add it to the en
+        #we save the size of the current step for further treatment
+        if len(np.shape(stepvar)) == 0:
+            self.sizes.append(1)
+            self.data.append(stepvar)
+        # if it is an array we add the values one by one
+        #we save the size of the current step for further treatment
+        else:
+            self.sizes.append(len(stepvar))
+            for r in stepvar:
                 self.data.append(r)
 
     def finalize(self, rows):
+        #we have more scalars than steps, so we have an array
         if len(self.data) > rows:
-            return np.reshape(self.data, newshape=(rows, int(len(self.data) / rows)))
+            #first check if all steps are the same size
+            SameSize = np.sum(np.asarray(self.sizes) - self.sizes[0]) == 0
+            if SameSize:
+                #same size for all steps, just reshape
+                return np.reshape(self.data, newshape=(rows, int(len(self.data) / rows)))
+            else:
+                #different sizes at each steps, first create a table big enough for the biggest step
+                startpoint = 0
+                datadim = len(np.shape(self.data))
+                if datadim == 1:
+                    outdat = np.nan * np.ones((rows, np.nanmax(self.sizes)))
+                    for step in range(rows):
+                        curlen = self.sizes[step]
+                        outdat[step, :curlen] = self.data[startpoint: startpoint + curlen]
+                        startpoint += curlen
+                elif datadim == 2:
+                    outdat = np.nan * np.ones((rows, np.nanmax(self.sizes), np.shape(self.data)[1]))
+                    for step in range(rows):
+                        curlen = self.sizes[step]
+                        outdat[step, :curlen, :] = self.data[startpoint: startpoint + curlen]
+                        startpoint += curlen
+
+                else:
+                    print("ERROR, reult treatment cant cope with dimensions above 2")
+                return outdat
+        #as much scalars as stpes (or less) so just one value per step
         else:
             return np.asarray(self.data)
@@ -47,4 +79,6 @@
     except AttributeError:  #no transient so just one timestep
         StepNum = 1
+    except TypeError:  #this isnot a result so no results in there
+        StepNum = 0
     TimeDim = NCData.createDimension('Time', StepNum)  # time is first
     DimDict = {len(TimeDim): 'Time'}
@@ -64,5 +98,5 @@
             DimDict[len(NewDim)] = dimnames[i]
 
-    typelist = [bool, str, str, int, float, complex,
+    typelist = [bool, str, int, float, complex,
                 collections.OrderedDict,
                 np.int64, np.ndarray, np.float64]
@@ -80,5 +114,9 @@
         NCgroup = NCData.createGroup(str(group))
         # In each group gather the fields of the class
-        fields = dict.keys(md.__dict__[group].__dict__)
+        try:
+            fields = dict.keys(md.__dict__[group].__dict__)
+        except AttributeError:
+            print("WARNING: md.{} as no fields, we skip it.".format(group))
+            continue
         # looping on fields in each group
         for field in fields:
@@ -119,4 +157,5 @@
                             if subfield not in['errlog', 'outlog']:
                                 StackedVar = ResTable()
+                                #first loop over the field (result type) to find the index of the last subfield (variable)
                                 for listindex in range(0, Listsize):
                                     try:
@@ -129,4 +168,5 @@
                                         lastindex = listindex
                                         continue
+                                    #Add the  subfield at the current step
                                     Var = SqueezeVar(Var)
                                     StackedVar.update(Var)
@@ -220,4 +260,16 @@
                             if ncvar is not None:
                                 FillVar(ncvar, StackedVar)
+                elif type(md.__dict__[group].__dict__[field]).__name__ == 'dict':
+                    # designed for a dict in dummy but might be used elsewhere
+                    # there is no subgroup
+                    klass = type(md.__dict__[group]).__module__ + '.' + type(md.__dict__[group]).__name__
+                    NCgroup.__setattr__('classtype', klass)
+                    Var = md.__dict__[group].__dict__[field]
+                    Var = SqueezeVar(Var)
+                    if verbose > 4:
+                        print("=WW=creating var for {}.{}".format(group, field))
+                    DimDict, ncvar = CreateVar(NCData, Var, field, NCgroup, DimDict)
+                    if ncvar is not None:
+                        FillVar(ncvar, Var)
                 else:
                     klass = type(md.__dict__[group]).__module__ + '.' + type(md.__dict__[group]).__name__
@@ -258,5 +310,5 @@
     # grab dimension
     if val_type in [collections.OrderedDict, dict]:
-        val_shape = len(var)
+        val_shape = len(var.keys())
         val_dim = 2
     else:
@@ -304,5 +356,5 @@
             ncvar = Group.createVariable(str(field), nctype, dimensions=dimensions, zlib=True)
     # treating bool tables and dict as string tables
-    elif val_type in ['bool', collections.OrderedDict, dict]:
+    elif val_type in [collections.OrderedDict, dict, 'bool']:
         if val_shape in [(), (0,), 0]:
             ncvar = Group.createVariable(str(field), str, zlib=True)
@@ -310,5 +362,5 @@
             dimensions, DimDict = GetDim(NCData, val_shape, val_type, DimDict, val_dim)
             ncvar = Group.createVariable(str(field), str, dimensions=dimensions, zlib=True)
-        # Now dealing with numeric variables
+    # Now dealing with numeric variables
     elif val_type in [float, 'float64', np.float64, int, 'int64']:
         if val_shape in [(), (0,), 0] and not SupDim:
Index: issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 25994)
+++ issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 26744)
@@ -67,9 +67,12 @@
         for solution in solnames:
             #looking for multiple time steps
-            if (np.size(res_struct.__dict__[solution]) > num_of_timesteps):
-                num_of_timesteps = np.size(res_struct.__dict__[solution])
-                num_of_timesteps = int(num_of_timesteps)
-                if 'Surface' in dict.keys(res_struct.__dict__[solution][0].__dict__):
-                    moving_mesh = True
+            try:
+                if len(res_struct.__dict__[solution]) > num_of_timesteps:
+                    num_of_timesteps = len(res_struct.__dict__[solution])
+                    num_of_timesteps = int(num_of_timesteps)
+                    if 'Surface' in dict.keys(res_struct.__dict__[solution][0].__dict__):
+                        moving_mesh = True
+            except TypeError:
+                continue
     else:
         num_of_timesteps = 1
@@ -92,4 +95,5 @@
         raise BadDimension('exportVTK does not support your element type')
 
+    #only keep the envelope and not the bulk of the results.
     if enveloppe:
         if dim == 3:
@@ -252,28 +256,42 @@
             for sol in solnames:
                 treated_res = []
-    #dealing with results on different timesteps
-                if(np.size(res_struct.__dict__[sol]) > timestep):
-                    timestep = step
-                else:
-                    timestep = np.size(res_struct.__dict__[sol])
-
-    #getting the  fields in the solution
-                if(type(res_struct.__dict__[sol]) == list):
+                #dealing with results on different timesteps
+                try:
+                    if(len(res_struct.__dict__[sol]) > timestep):
+                        timestep = step
+                    else:
+                        timestep = np.size(res_struct.__dict__[sol])
+                except TypeError:
+                    #result as no len() so no timesteps
+                    timestep = 1
+
+                #getting the  fields in the solution
+                if(type(res_struct.__dict__[sol]).__name__ == 'solution'):
                     spe_res_struct = res_struct.__dict__[sol].__getitem__(timestep)
                     fieldnames = dict.keys(spe_res_struct.__dict__)
-                else:
+                elif(type(res_struct.__dict__[sol]).__name__ == 'solutionstep'):
                     spe_res_struct = res_struct.__dict__[sol]
                     fieldnames = dict.keys(spe_res_struct.__dict__)
-
-    #Sorting scalars, vectors and tensors
+                elif(type(res_struct.__dict__[sol]).__name__ == 'results'):  #this is a result without steps
+                    spe_res_struct = res_struct.__dict__[sol]
+                    fieldnames = dict.keys(spe_res_struct.__dict__)
+                else:
+                    print("WARNING, solution type '{}' is not recognise, exported results might be wrong".format(type(res_struct.__dict__[sol])))
+                    spe_res_struct = res_struct.__dict__[sol]
+                    fieldnames = dict.keys(spe_res_struct.__dict__)
+
+                #Sorting scalars, vectors and tensors
                 tensors = [field for field in fieldnames if field[-2:] in ['xx', 'yy', 'xy', 'zz', 'xz', 'yz']]
                 non_tensor = [field for field in fieldnames if field not in tensors]
                 vectors = [field for field in non_tensor if field[-1] in ['x', 'y', 'z'] and field[-4:] not in ['Flux']]
 
-    #check which field is a real result and print
+                #check which field is a real result and print
                 for field in fieldnames:
+                    print("Treating {}".format(field))
                     if field in treated_res:
+                        print("{} is already done".format(field))
                         continue
                     elif field in vectors:
+                        print("{} is a vector".format(field))
                         try:
                             Vxstruct = np.squeeze(spe_res_struct.__dict__[field[:-1] + 'x'])
@@ -299,4 +317,5 @@
 
                     elif field in tensors:
+                        print("{} is a tensor".format(field))
                         try:
                             Txxstruct = np.squeeze(spe_res_struct.__dict__[field[:-2] + 'xx'])
@@ -346,5 +365,4 @@
                         else:
                             print("format for field {}.{} is not suported, field is skipped".format(sol, field))
-                            continue
     # }}}
     # loop on arguments, if something other than result is asked, do it now {{{
Index: issm/trunk/src/m/contrib/dlcheng/zoneaverage.m
===================================================================
--- issm/trunk/src/m/contrib/dlcheng/zoneaverage.m	(revision 26744)
+++ issm/trunk/src/m/contrib/dlcheng/zoneaverage.m	(revision 26744)
@@ -0,0 +1,79 @@
+function avg=zoneaverage(md,field,parameter,width,distweight,areaweight,iter)
+%ZONEAVERAGE - averages the field over the elements within the distance specified by parameter .* width. 
+%               Average is weighted by the element area using model's triangulation.
+%               Width determines distance multiplier of parameter when calculating a node's distance for inclusion in an average.
+%               Distweight and Areaweight control how the node distance and area affect the weighted average.
+%               Iteration is the number of iterations to run the zone averaging.
+%
+%   Usage:
+%      avg=zone_average(md,field,parameter,width,distweight,areaweight)
+
+%TODO: HANDLE NARGINS/PAIROPTION STYLE ARGS FOR WIDTH, DISTWEIGHT, AREAWEIGHT, ITER
+
+if (dimension(md.mesh)==2),
+	numberofelements=md.mesh.numberofelements;
+	numberofnodes=md.mesh.numberofvertices;
+	index=md.mesh.elements;
+	x=md.mesh.x; y=md.mesh.y;
+else
+	numberofelements=md.mesh.numberofelements2d;
+	numberofnodes=md.mesh.numberofvertices2d;
+	index=md.mesh.elements2d;
+	x=md.mesh.x2d; y=md.mesh.y2d;
+end
+
+%node
+if numel(field)==numberofnodes,
+    areas=GetAreas(md.mesh.elements,md.mesh.x,md.mesh.y);
+
+    %calculate distances between nodes and reshape into addressable matrix
+    nodes=[md.mesh.x, md.mesh.y];
+    dist=pdist([nodes;nodes]);
+    dist=squareform(dist);
+    dist=dist(1:numberofnodes,numberofnodes+1:end);
+
+    %calculate max distance to average each vertex using parameter * width and mask distances
+    maxdist = parameter * width;
+    flags=dist<=maxdist;
+    
+    %calculate average area per node
+    nodeareas=zeros(numberofnodes,1);
+    elementspernode=zeros(numberofnodes,1);
+    for i=1:numberofelements,
+        for j=1:3,
+            node=index(i,j);
+            nodeareas(node)=nodeareas(node)+areas(i);
+            elementspernode(node)=elementspernode(node)+1;
+        end
+    end
+    nodeareas=nodeareas./elementspernode;
+    
+    %get distance/area weighted average of field within specified parameter width
+    avg=zeros(numberofnodes,1);
+    totalweight=distweight+areaweight;
+    distweight=distweight/totalweight;
+    areaweight=areaweight/totalweight;
+    for iter=1:iter,
+%     for iter=1:1,
+        for i=1:numberofnodes,
+            %distance weighting
+            distsum = sum(dist(i,flags(i,:))) + eps;
+            distmax = max(dist(i,flags(i,:)));
+            distweights = ones(sum(flags(i,:)),1);
+            distweights = distweights + 1 - distweight*(dist(i,(flags(i,:)))'/distsum); %inverse linear distance weight
+            distweights = distweights / sum(distweights);
+
+            %area weighting
+            areasum = sum(nodeareas(flags(i,:))) + eps;
+            areaweights = areaweight*nodeareas(flags(i,:))/areasum;
+            weights=distweights+areaweights;
+            avg(i)=nansum(weights.*field(flags(i,:)));
+            %avg(i)=nanmean(field(flags(i,:)),1);
+
+    %         areasum = sum(nodeareas(flags));
+    %         weights = nodeareas(flags)/areasum;
+    %         avg=nanmean(weights.*field(flags),2);
+        end
+        field=avg;
+    end
+end
Index: issm/trunk/src/m/contrib/morlighem/ad/rescalegradient.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/ad/rescalegradient.m	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/ad/rescalegradient.m	(revision 26744)
@@ -14,7 +14,7 @@
 	disp('Constructing mass matrix...');
 	tic
-	row   = zeros(10*md.mesh.numberofvertices);
-	col   = zeros(10*md.mesh.numberofvertices);
-	value = zeros(10*md.mesh.numberofvertices);
+	row   = zeros(10*md.mesh.numberofvertices,1);
+	col   = zeros(10*md.mesh.numberofvertices,1);
+	value = zeros(10*md.mesh.numberofvertices,1);
 
 	%Construct mass matrix using MATLAB's sparse function
Index: issm/trunk/src/m/contrib/morlighem/modeldata/InterpFromGrid.cpp
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/InterpFromGrid.cpp	(revision 25994)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/InterpFromGrid.cpp	(revision 26744)
@@ -243,5 +243,5 @@
 
 				if(n0<0 || n3>=dataN || m0<0 || m3>=dataM){
-					interp[idx] = -9999;
+					interp[idx] = -9999.;
 					continue;
 				}
